package at.ac.tuwien.vitalab.genesis2.control

import groovy.ui.Console

import java.util.concurrent.Semaphore

/**
 * G2 extenstion to the groovy console.
 * 
 * @author Lukasz Juszczyk
 *
 */
class G2Console extends Console {

    Semaphore sem=null;

    String lastScript=null

    public G2Console(Binding binding, Semaphore sem) {
	super(binding)
	this.sem=sem
    }


    void exit(EventObject evt = null) {
	sem.release()
	super.exit(evt)
    }


    /* (non-Javadoc)
     * @see groovy.ui.Console#loadScriptFile(java.io.File)
     */
    @Override
    public void loadScriptFile(File file) {
	super.loadScriptFile(file);
	if (shell!=null) {
	    shell.setId(Genesis2Frontend.getScriptIdFromFile(file));
	}
    }

    /* (non-Javadoc)
     * @see groovy.ui.Console#setShell(groovy.lang.GroovyShell)
     */
    @Override
    public void setG2Shell(InterceptingGroovyShell arg0) {
	this.shell=arg0;
	super.setShell(arg0);
    }

    void runScript(EventObject evt = null) {

	super.runScript(evt)

	commentOldScript()
    }

    void runSelectedScript(EventObject evt = null) {

	super.runSelectedScript(evt)

	commentOldScript()
    }

    private void commentOldScript() {

	String newScript=""

	BufferedReader br=new BufferedReader(new StringReader(inputArea.text))

	String l = null;
	while ((l = br.readLine())!=null) {
	    if (!l.startsWith("// ")) {
		l="// "+l
	    }
	    newScript+=l+"\n"
	}
	inputArea.text=newScript+"\n"
    }
}
