package at.ac.tuwien.vitalab.genesis2.config;

/**
 * Checks configuration entries for validity.
 * 
 * @author Lukasz Juszczyk
 * 
 */
public interface IConfigEntryChecker {

    /**
     * Checks whether the config value is valid. In case of invalid entries
     * either an exception is thrown or <code>false</code> is returned.
     * 
     * @param value Value.
     * 
     * @return <code>true</code> if valid, otherwise <code>false</code>.
     * 
     * @throws IllegalArgumentException If not valid.
     */
    boolean check(String value) throws IllegalArgumentException;

}
