package at.ac.tuwien.vitalab.genesis2.core.model;

/**
 * Interface for objects that observe model elements.
 * 
 * @author Lukasz Juszczyk
 * 
 * @param <T> Type of observed elements.
 */

public interface IModelObserver<T extends AbstractModelElement> {

    /**
     * New model state.
     */
    int CREATED = 1;

    /**
     * New model state.
     */
    int REMOVED = 2;

    /**
     * New model state.
     */
    int DEPLOYED = 3;

    /**
     * New model state.
     */
    int UNDEPLOYED = 4;

    /**
     * New model state.
     */
    int UPDATED = 5;

    /**
     * Called on a newly deployed model element.
     * 
     * @param element Element.
     * @param how What has changed.
     * @param info Additional information about the change.
     */
    void onChangedModelElement(T element, int how, Object... info);

}
