package at.ac.tuwien.vitalab.genesis2.core.model.types;

import at.ac.tuwien.vitalab.genesis2.errors.G2Exception;

/**
 * Fake host for deployment of artifacts that must be hosted on a different
 * port.
 * 
 * @author Lukasz Juszczyk
 * 
 */
public class FakeHost extends Host {

    /**
     * Constructor.
     */
    public FakeHost() {
	super();
    }

    /**
     * Constructor.
     * 
     * @param host Host.
     * @param port Port.
     */
    public FakeHost(String host, int port) {
	super(host, port);
    }

    /*
     * (non-Javadoc)
     * 
     * @see
     * at.ac.tuwien.vitalab.genesis2.core.model.types.Host#checkHost(boolean)
     */
    @Override
    protected void checkHost(boolean purge) {
	// do nothing
    }

    /*
     * (non-Javadoc)
     * 
     * @see at.ac.tuwien.vitalab.genesis2.core.model.types.Host#installPlugins()
     */
    @Override
    protected void installPlugins() throws G2Exception {
	// do nothing
    }

    /*
     * (non-Javadoc)
     * 
     * @see at.ac.tuwien.vitalab.genesis2.core.model.types.Host#purge()
     */
    @Override
    public synchronized void purge() {
	// do nothing
    }

}
