package at.ac.tuwien.vitalab.genesis2.plugin;

import at.ac.tuwien.vitalab.genesis2.core.model.AbstractModelElement;

/**
 * Interface for plugin deployment observers.
 * 
 * @author Lukasz Juszczyk
 * 
 */
public interface IPluginObserver {

    /**
     * Called on started plugins.
     * 
     * @param plugin Plugin instance.
     */
    void onPluginStarted(AbstractGenesis2Plugin<? extends AbstractModelElement> plugin);

    /**
     * Called on stopped plugins.
     * 
     * @param plugin Plugin instance.
     */
    void onPluginStopped(AbstractGenesis2Plugin<? extends AbstractModelElement> plugin);
}
