package at.ac.tuwien.vitalab.genesis2.plugin.callinterceptor;

import groovy.lang.Closure;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import at.ac.tuwien.vitalab.genesis2.core.model.AbstractModelElement;
import at.ac.tuwien.vitalab.genesis2.core.model.builder.AbstractModelBuilder;

/**
 * Builder for CallInterceptors.
 * 
 * @author Lukasz Juszczyk
 * 
 */
public class CallInterceptorBuilder extends AbstractModelBuilder<CallInterceptor> {

    /*
     * (non-Javadoc)
     * 
     * @see at.ac.tuwien.vitalab.genesis2.core.model.builder.AModelBuilder#
     * attachOrphanedChild
     * (at.ac.tuwien.vitalab.genesis2.core.model.AModelElement,
     * at.ac.tuwien.vitalab.genesis2.core.model.AModelElement)
     */
    @Override
    protected void attachOrphanedChild(CallInterceptor parent, AbstractModelElement child) {
	// no nested types
    }

    /*
     * (non-Javadoc)
     * 
     * @see
     * at.ac.tuwien.vitalab.genesis2.core.model.builder.AModelBuilder#nextChildType
     * (java.lang.Object, java.lang.Object, java.util.Map)
     */
    @Override
    protected Class<? extends AbstractModelElement> nextChildType(Object name, Object value, Map<?, ?> attributes) {
	return null;
    }

    /*
     * (non-Javadoc)
     * 
     * @see
     * at.ac.tuwien.vitalab.genesis2.core.model.builder.AModelBuilder#processArgs
     * (java.util.List)
     */
    @SuppressWarnings("unchecked")
    @Override
    protected List<?> processArgs(List<?> args) {

	List<Object> result = new ArrayList<Object>();

	Map<Object, Object> map = new HashMap<Object, Object>();
	result.add(map);

	for (Object a : args) {
	    if (a instanceof Map) {
		map.putAll((Map<Object, Object>) a);
	    } else if (a instanceof Closure) {
		map.put("code", a);
	    } else {
		result.add(a);
	    }
	}

	return result;
    }
}
