package at.ac.tuwien.vitalab.genesis2.plugin.hostlist.ws;

import java.util.Collection;
import java.util.List;

import javax.jws.WebService;

import at.ac.tuwien.vitalab.genesis2.plugin.hostlist.HostListPlugin;

/**
 * Web service for updating the host list.
 * 
 * @author Lukasz Juszczyk
 * 
 */
@WebService(endpointInterface = "at.ac.tuwien.vitalab.genesis2.plugin.hostlist.ws.IHostListWebService", serviceName = "IHostListWebService")
public class HostListWebService implements IHostListWebService {

    private Collection<String> hosts = null;

    public HostListWebService(HostListPlugin plugin, Collection<String> hosts) {
	super();
	this.hosts = hosts;
    }

    /*
     * (non-Javadoc)
     * 
     * @see
     * at.ac.tuwien.vitalab.genesis2.plugin.hostlist.ws.IHostListWebService#
     * setHosts(java.util.List)
     */
    @Override
    public void setHosts(List<String> hostsAndPorts) {
	synchronized (hosts) {
	    hosts.clear();
	    hosts.addAll(hostsAndPorts);
	}
    }

}
