package at.ac.tuwien.vitalab.genesis2.plugin.propagator.ws;

import java.util.List;

import javax.jws.WebService;

import at.ac.tuwien.vitalab.genesis2.base.ExecutionEnvironment;
import at.ac.tuwien.vitalab.genesis2.core.model.ws.wrappers.KeyValueWrapper;

/**
 * Web service for Object Propagator Plugin.
 * 
 * @author Lukasz Juszczyk
 * 
 */
@WebService(endpointInterface = "at.ac.tuwien.vitalab.genesis2.plugin.propagator.ws.IObjectPropagatorWebService", serviceName = "IObjectPropagatorWebService")
public class ObjectPropagatorWebService implements IObjectPropagatorWebService {

    private static final ExecutionEnvironment GLOBAL_ENV = ExecutionEnvironment.getGlobalInstance();

    /*
     * (non-Javadoc)
     * 
     * @see at.ac.tuwien.vitalab.genesis2.plugin.propagator.ws.
     * IObjectReplicatorWebService
     * #set(at.ac.tuwien.vitalab.genesis2.core.model.ws
     * .wrappers.KeyValueWrapper)
     */
    @Override
    public void set(List<KeyValueWrapper> kvws) {

	if (kvws != null) {
	    for (KeyValueWrapper kvw : kvws) {
		GLOBAL_ENV.setVariable(kvw.getUnwrappedKey().toString(), kvw.getUnwrappedValue());
	    }
	}
    }
}
