package at.ac.tuwien.vitalab.genesis2.plugin.registry.ws;

import java.util.List;

import javax.jws.WebMethod;
import javax.jws.WebService;

import at.ac.tuwien.vitalab.genesis2.core.model.ws.wrappers.ClosureWrapper;
import at.ac.tuwien.vitalab.genesis2.core.model.ws.wrappers.ModelElementWrapper;

/**
 * Interface for registry Web service.
 * 
 * @author Lukasz Juszczyk
 * 
 */
@WebService(name = "SimpleWebServiceRegistry")
public interface IRegistryWebService {

    /**
     * Returns list of WsReference.
     * 
     * @param filter Filter closure.
     * @param requiredProps List of property names which should be
     *            provided.
     * 
     * @return URLs.
     */
    @WebMethod
    List<ModelElementWrapper> get(ClosureWrapper filter, List<String> requiredProps);

}
